--- alsa-plugins-1.0.24.orig/pulse/pulse.c	2011-01-26 11:05:44.000000000 +0000
+++ alsa-plugins-1.0.24/pulse/pulse.c	2011-09-26 16:49:43.000000000 +0100
@@ -114,6 +114,10 @@
 	return fcntl(fd, F_SETFL, fl | O_NONBLOCK);
 }
 
+static int make_close_on_exec(int fd) {
+    return fcntl(fd, F_SETFD, FD_CLOEXEC);
+}
+
 snd_pulse_t *pulse_new(void)
 {
 	snd_pulse_t *p;
@@ -134,7 +138,9 @@
 	p->thread_fd = fd[1];
 
 	make_nonblock(p->main_fd);
+	make_close_on_exec(p->main_fd);
 	make_nonblock(p->thread_fd);
+	make_close_on_exec(p->thread_fd);
 
 	p->mainloop = pa_threaded_mainloop_new();
 	if (!p->mainloop)
